#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_FishChuBaoCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_FishChuBaoCFG> Fish_FishChuBaoCFG::msSingleton(nullptr);

int Fish_FishChuBaoCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_FishChuBaoCFGData* Fish_FishChuBaoCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_FishChuBaoCFGData>& Fish_FishChuBaoCFG::GetMapData()
{
	return mMapData;
}

void Fish_FishChuBaoCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_FishChuBaoCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_FishChuBaoCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mFishId = element->IntAttribute("FishId");
		data.mTurretMin = element->IntAttribute("TurretMin");
		data.mTurretMax = element->IntAttribute("TurretMax");
		data.mScore = element->IntAttribute("Score");
		data.mWeight = element->IntAttribute("Weight");
		data.mGold = element->IntAttribute("Gold");
		{
			const char* GivenReward = element->Attribute("GivenReward");
			std::vector<std::string> vecGivenReward;
			boost::split(vecGivenReward, GivenReward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGivenReward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGivenReward[i].c_str(), &temp))
				{
					data.mGivenReward.push_back(temp);
				}
			}
		}
		data.mGearName = element->Attribute("GearName");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_FishChuBaoCFG::Load()
{
	Load("../Config/Fish_FishChuBaoCFG.xml");
}

Fish_FishChuBaoCFG* Fish_FishChuBaoCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_FishChuBaoCFG());
	}
	return msSingleton.get();
}
